#[doc = "Register `DPIN1` reader"]
pub struct R(crate::R<DPIN1_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<DPIN1_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<DPIN1_SPEC>> for R {
    fn from(reader: crate::R<DPIN1_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `DPIN1` writer"]
pub struct W(crate::W<DPIN1_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<DPIN1_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<DPIN1_SPEC>> for W {
    fn from(writer: crate::W<DPIN1_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `PI_TOP2` reader - RAM configuration bits (2) for TOP UDB port interface configuration"]
pub struct PI_TOP2_R(crate::FieldReader<u8, u8>);
impl PI_TOP2_R {
    pub(crate) fn new(bits: u8) -> Self {
        PI_TOP2_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PI_TOP2_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PI_TOP2` writer - RAM configuration bits (2) for TOP UDB port interface configuration"]
pub struct PI_TOP2_W<'a> {
    w: &'a mut W,
}
impl<'a> PI_TOP2_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 2)) | ((value as u8 & 0x03) << 2);
        self.w
    }
}
#[doc = "Field `PI_BOT2` reader - RAM configuration bits (2) for BOTTOM UDB port interface configuration"]
pub struct PI_BOT2_R(crate::FieldReader<u8, u8>);
impl PI_BOT2_R {
    pub(crate) fn new(bits: u8) -> Self {
        PI_BOT2_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PI_BOT2_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PI_BOT2` writer - RAM configuration bits (2) for BOTTOM UDB port interface configuration"]
pub struct PI_BOT2_W<'a> {
    w: &'a mut W,
}
impl<'a> PI_BOT2_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 4)) | ((value as u8 & 0x03) << 4);
        self.w
    }
}
impl R {
    #[doc = "Bits 2:3 - RAM configuration bits (2) for TOP UDB port interface configuration"]
    #[inline(always)]
    pub fn pi_top2(&self) -> PI_TOP2_R {
        PI_TOP2_R::new(((self.bits >> 2) & 0x03) as u8)
    }
    #[doc = "Bits 4:5 - RAM configuration bits (2) for BOTTOM UDB port interface configuration"]
    #[inline(always)]
    pub fn pi_bot2(&self) -> PI_BOT2_R {
        PI_BOT2_R::new(((self.bits >> 4) & 0x03) as u8)
    }
}
impl W {
    #[doc = "Bits 2:3 - RAM configuration bits (2) for TOP UDB port interface configuration"]
    #[inline(always)]
    pub fn pi_top2(&mut self) -> PI_TOP2_W {
        PI_TOP2_W { w: self }
    }
    #[doc = "Bits 4:5 - RAM configuration bits (2) for BOTTOM UDB port interface configuration"]
    #[inline(always)]
    pub fn pi_bot2(&mut self) -> PI_BOT2_W {
        PI_BOT2_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "UDB Channel PI Tile Configuration; Datapath Input\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [dpin1](index.html) module"]
pub struct DPIN1_SPEC;
impl crate::RegisterSpec for DPIN1_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [dpin1::R](R) reader structure"]
impl crate::Readable for DPIN1_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [dpin1::W](W) writer structure"]
impl crate::Writable for DPIN1_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets DPIN1 to value 0"]
impl crate::Resettable for DPIN1_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
